'use strict';

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

function wrapToArray(obj) {
  if (!obj) {
    return [];
  } else if (obj instanceof Array) {
    return obj;
  }

  return [obj];
}

function checkAirbnb(configs) {
  if (configs.indexOf('airbnb') !== -1) {
    return ['eslint-config-airbnb', 'babel-eslint', 'eslint-plugin-react', 'eslint'];
  } else if (configs.indexOf('airbnb/base') !== -1) {
    return ['eslint-config-airbnb', 'babel-eslint', 'eslint'];
  } else if (configs.indexOf('airbnb/legacy') !== -1) {
    return ['eslint-config-airbnb', 'eslint'];
  }

  return false;
}

exports['default'] = function (content, filename) {
  var basename = _path2['default'].basename(filename);
  if (basename === '.eslintrc') {
    var configs = wrapToArray(JSON.parse(content)['extends']);

    var airbnbResult = checkAirbnb(configs);
    if (airbnbResult) {
      return airbnbResult;
    }

    return [];
  }

  return [];
};

module.exports = exports['default'];