'use strict';

var _Promise = require('babel-runtime/core-js/promise')['default'];

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = output;
function noUnused(result) {
  return result.dependencies.length === 0 && result.devDependencies.length === 0;
}

function prettify(caption, deps) {
  var list = deps.map(function (dep) {
    return '* ' + dep;
  });
  return list.length ? [caption].concat(list) : [];
}

function output(result, log, json) {
  return new _Promise(function (resolve) {
    if (json) {
      log(JSON.stringify(result));
    } else if (noUnused(result)) {
      log('No unused dependencies');
    } else {
      var deps = prettify('Unused Dependencies', result.dependencies);
      var devDeps = prettify('\nUnused devDependencies', result.devDependencies);
      var content = deps.concat(devDeps).join('\n');

      log(content);
    }

    resolve(result);
  });
}

module.exports = exports['default'];